# start here

感谢您在Coursera上注册编程语言。这是一个具有挑战性的课程，我们希望它将永远改变您看待编程的方式。许多人喜欢这门课程，并发现它是最具挑战性和回报的MOOC之一。许多人已经进行了许多准备工作，我们希望您能参与我们将共同探索的美好话题感到兴奋。

在深入学习课程资料之前，请花费大约一个小时，以使用本模块中的视频和阅读材料来熟悉课程。在内容方面，我们描述了值得您仔细考虑的推荐背景。在课程政策方面，我们做的事情与许多我们希望事先明确的Coursera MOOC有所不同。我们知道在Internet上浏览和跳过内容是正常的，但是我们确实认为您需要所有这些后勤信息，并且我们会努力将“可选”标记为我们认为您可以跳过的任何内容。

在软件方面，需要做的工作是安装所有您需要的东西-这些细节在下一个模块中，您可以立即进行安装，也可以等到在第一个“真实”模块中观看了一些视频之后再进行安装。无论哪种情况，您都需要先安装软件，然后再进行作业1。

这是一个待办事项清单，可帮助您指导这一初始阶段。一些稍微不同的命令可能会起作用。

观看本模块中的课程介绍视频，以了解课程动机，假定的背景知识和后勤知识。
阅读有关更详细的课程政策和其他观点的阅读材料-可能不需要的部分已明确标记。
获得安装“编程语言，A部分”所需的软件。我们知道这些说明可能有点吓人（涵盖各种操作系统和选件），但是仔细耐心地进行操作将不会太耗时。
练习作业0。这种假作业完全是可选的，不会影响成绩。这是一个机会，可以适应课程中的作业格式以及如何提交作业。在覆盖了第1节的某些材料之后，您可能更喜欢练习上交该假作业（如果您选择这样做），因为在看完某些课程内容后，作业0更有意义。在第1节之前，我们并不期望代码有意义，但是没有必要理解代码。
继续进行第1节的学习。尽管“第2周”中列出了第1节和“作业1”，但我们建议从本周开始学习，这样您可以有一个多星期的时间来完成它，并按计划进行。

## 课程简介

在“课程资源”选项卡中也会重复阅读该内容，以便在整个课程中更容易查找。

本课程介绍编程语言的基本概念，并特别强调函数式编程。本课程使用语言ML（在A部分中），球拍（在B部分中）和Ruby（在C方面）作为讲授概念的媒介，但是真正的目的是要讲授足够多的关于任何语言如何“适合”使用的语言使您可以使用任何一种语言和学习新语言来进行更有效的编程。

本课程既不是理论性的课程，也不是关于编程细节的课程-它将为您提供一个框架，让您了解如何有效地使用语言结构以及如何设计正确而优雅的程序。通过使用不同的语言，您将学会比一种语言的特定语法更深入地思考。对函数式编程的重视对于学习如何编写健壮，可重用，可组合且精致的程序至关重要。实际上，现代语言中许多最重要的思想都源于函数式编程。准备学习一种新颖美观的软件查看方法，以及如何享受构建软件的乐趣。

有关课程将涵盖的特定主题列表，请参见下文。

### 推荐背景

本课程假定学生熟悉大多数入门课程涵盖的编程，但是明确地将其设计为不是特别高级的课程。学生应该对变量，条件，数组，链表，堆栈和递归感到满意（尽管递归将被审查和扩展），以及接口和实现之间的区别。学生应该渴望用新的语言编写程序。本课程的C部分分析了基本的面向对象的概念，并将其与其他语言的概念进行了对比，因此熟悉Java或密切相关的语言（例如C＃）可能会有所帮助，但对于C部分的分配则没有必要。

本课程基于为二年级和三年级本科生设计的课程：不是第一门计算机科学课程，也不是高级课程。因此，它当然不会涵盖编程语言这个美丽世界中的所有内容，但是它是可靠的介绍。

入门视频和其他阅读材料更详细地讨论了假定的背景。

### 课程目标

成功的课程参与者将：

- 内化对函数和面向对象程序的含义的准确理解
- 培养快速学习新的编程语言所需的技能
- 掌握特定的语言概念，以便他们可以以奇怪的伪装识别它们
- 学习评估编程语言及其结构的强大功能和优雅程度
- 精通ML，Racket和Ruby语言---并且作为副产品，变得更加精通他们已经知道的语言

### 忠告

我们希望您喜欢这门课程并从中学到很多。本课程的设计并不容易，因为这是向您提供全面的计算机科学核心经验的机会。一些建议专门适用于本课程：

- 给自己时间去适应新的语言和编程环境。学习新工具，遇到陌生的错误消息等可能会令人迷失方向。如果您的唯一目标是尽快完成作业，可能会感到沮丧。确实，此策略可能适得其反：完成作业需要更长的时间。相反，在开始分配作业时，喜欢在示例和小型程序之间“玩转”。  
  
- 在课程的前两周要特别耐心并确定。在这段时间里，您将进行的编程感觉可能完全不同于您以前做过的任何事情，这可能会使您以前的经验变得更加沮丧。坚持下去。根据我们的经验，一旦您完成一到两本家庭作业，尽管希望我们发现所有这些都令人愉快，但采用课程方法可能会感到更加舒适和有益。
  
如果您通过说“我将很有趣地学习用新的方式思考”来学习本课程，那么您会做得很好。如果您改为说：“我将尽我所能，将所见即所得融入我对编程的看法”，那么您可能会感到沮丧。到最后，课程材料将与您所了解的内容相关，但要有耐心。
本课程材料有时以微妙的方式构建。因此，即使看起来很容易，也不要着急通过早期的材料，或者您可以在没有所有细节的情况下猜测正在发生的事情。我们正在建立重要的基础。
通过思考作业与讲义材料的关系来处理作业。您将要编写的程序通常比讲座中的程序复杂一些，但是您应该使用相同的概念。尤其是在早期的作业中，您将不需要想出很多窍门，也不需要学习超出讲座范围的东西。
对于考试，应将重点更多地放在概念上，而不仅仅是编写程序。考试题将涉及每种题，但作业中涉及的概念性题越少，因此您需要做更多的工作来学习。
通过阅读他人的代码将同级评估当作学习的好机会：既可以找到好的示例，也可以学习导致他人难以理解的自己的代码。我们坚信，同行评估不仅是对程序风格进行评分的可扩展方式，还可以帮助您学习。
特定课程主题的大概列表
A部分：

语法，语义，惯用法，库，工具
ML基础知识（绑定，条件，记录，函数）
递归函数和递归类型
无突变的好处
代数数据类型，模式匹配
尾递归
高阶函数；关闭
词汇范围
咖喱
句法糖
等价和影响
参数多态和容器类型
类型推断
抽象类型和模块
B部分：

球拍基础
动态与静态类型
懒惰，流和记忆
实现语言，尤其是高阶函数
巨集
评估
C部分：

Ruby基础
面向对象的编程是动态调度
纯面向对象
实施动态调度
多重继承，接口和混合
OOP与功能分解和可扩展性
记录，函数和对象的子类型化
基于类的子类型
子类型化
子类型与参数多态性；有界多态性